---
title: let
slug: Web/JavaScript/Reference/Statements/let
tags:
  - ECMAScript 2015
  - JavaScript
  - Language feature
  - Statement
  - Variable declaration
  - Variables
  - let
---
<div>{{jsSidebar("Statements")}}</div>

<p>The <strong><code>let</code></strong> statement declares a block-scoped local variable, optionally initializing it to a value.</p>

<div>{{EmbedInteractiveExample("pages/js/statement-let.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <var>name1</var> [= <var>value1</var>] [, <var>name2</var> [= <var>value2</var>]] [, ..., <var>nameN</var> [= <var>valueN</var>];</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code><var>nameN</var></code></dt>
	<dd>The names of the variable or variables to declare. Each must be a legal JavaScript identifier.</dd>
	<dt><code><var>value</var></code><code><var>N</var></code> {{optional_inline}}</dt>
	<dd>For each variable declared, you may optionally specify its initial value to any legal JavaScript expression.</dd>
</dl>

<p> Alternatively, the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Destructuring_assignment">Destructuring Assignment </a>syntax can also be used to declare variables.</p>

<pre class="syntaxbox notranslate">let <var>{ bar }</var> = <em>foo</em>; // where foo = { bar:10, baz:12 };
/* This creates a variable with the name 'bar', which has a value of 10 */</pre>

<h2 id="Description">Description</h2>

<p><strong><code>let</code></strong> allows you to declare variables that are limited to the scope of a {{jsxref("statements/block", "block", "", 1)}} statement, or expression on which it is used, unlike the {{jsxref("statements/var", "var")}} keyword, which declares a variable globally, or locally to an entire function regardless of block scope. The other difference between {{jsxref("statements/var", "var")}} and <code>let</code> is that the latter is initialized to a value only when a <a href="#Temporal_dead_zone">parser evaluates it (see below)</a>.</p>

<p>Just like {{jsxref("statements/const", "const", "Description")}} the <code>let</code> does <em>not</em> create properties of the {{domxref("window")}} object when declared globally (in the top-most scope).</p>

<p>An explanation of why the name "<strong>let</strong>" was chosen can be found <a href="https://stackoverflow.com/questions/37916940/why-was-the-name-let-chosen-for-block-scoped-variable-declarations-in-javascri">here</a>.</p>

<div class="notecard note">
<p>Many issues with <code>let</code> variables can be avoided by declaring them at the top of the scope in which they are used (doing so may impact readibility).</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Scoping_rules_2">Scoping rules</h3>

<p>Variables declared by <strong><code>let</code></strong> have their scope in the block for which they are declared, as well as in any contained sub-blocks. In this way, <strong><code>let</code></strong> works very much like <strong><code>var</code></strong>. The main difference is that the scope of a <strong><code>var</code></strong> variable is the entire enclosing function:</p>

<pre class="brush:js notranslate">function varTest() {
  var x = 1;
  {
    var x = 2;  // same variable!
    console.log(x);  // 2
  }
  console.log(x);  // 2
}

function letTest() {
  let x = 1;
  {
    let x = 2;  // different variable
    console.log(x);  // 2
  }
  console.log(x);  // 1
}
</pre>

<p id="Scoping_rules">At the top level of programs and functions, <strong><code>let</code></strong>, unlike <strong><code>var</code></strong>, does not create a property on the global object. For example:</p>

<pre class="brush:js notranslate">var x = 'global';
let y = 'global';
console.log(this.x); // "global"
console.log(this.y); // undefined
</pre>

<h3 id="Emulating_private_members">Emulating private members</h3>

<p>In dealing with {{Glossary("Constructor", "constructors")}} it is possible to use the <strong><code>let</code></strong> bindings to share one or more private members without using <a href="/en-US/docs/Web/JavaScript/Closures">closures</a>:</p>

<pre class="brush:js notranslate">var Thing;

{
  let privateScope = new WeakMap();
  let counter = 0;

  Thing = function() {
    this.someProperty = 'foo';

    privateScope.set(this, {
      hidden: ++counter,
    });
  };

  Thing.prototype.showPublic = function() {
    return this.someProperty;
  };

  Thing.prototype.showPrivate = function() {
    return privateScope.get(this).hidden;
  };
}

console.log(typeof privateScope);
// "undefined"

var thing = new Thing();

console.log(thing);
// Thing {someProperty: "foo"}

thing.showPublic();
// "foo"

thing.showPrivate();
// 1
</pre>

<p>The same privacy pattern with closures over local variables can be created with <code>var</code>, but those need a function scope (typically an {{Glossary("IIFE")}} in the module pattern) instead of just a block scope like in the example above.</p>

<h3 id="Redeclarations">Redeclarations</h3>

<p>Redeclaring the same variable within the same function or block scope raises a {{jsxref("SyntaxError")}}.</p>

<pre class="brush: js example-bad notranslate">if (x) {
  let foo;
  let foo; // SyntaxError thrown.
}
</pre>

<p>You may encounter errors in {{jsxref("Statements/switch", "switch")}} statements because there is only one block.</p>

<pre class="brush: js example-bad notranslate">let x = 1;
switch(x) {
  case 0:
    let foo;
    break;

  case 1:
    let foo; // SyntaxError for redeclaration.
    break;
}</pre>

<p>However, it's important to point out that a block nested inside a case clause will create a new block scoped lexical environment, which will not produce the redeclaration errors shown above.</p>

<pre class="brush: js notranslate">let x = 1;

switch(x) {
  case 0: {
    let foo;
    break;
  }
  case 1: {
    let foo;
    break;
  }
}</pre>

<h3 id="Temporal_dead_zone_TDZ">Temporal dead zone (TDZ)</h3>

<p><code>let</code> variables cannot be read/written until they have been fully initialized, which happens when they are declared (if no initial value is specified on declaration, the variable is initialized with a value of <code>undefined</code>). Accessing the variable before the initialization results in a {{jsxref("ReferenceError")}}.</p>

<div class="notecard note">
<p>This differs from {{jsxref("Statements/var", "var", "var_hoisting")}} variables, which will return a value of <code>undefined</code> if they are accessed before they are declared.</p>
</div>

<p>The variable is said to be in a "temporal dead zone" (TDZ) from the start of the block until the initialization has completed.</p>

<pre class="brush: js example-bad notranslate">{ // TDZ starts at beginning of scope
  console.log(bar); // undefined
  console.log(foo); // ReferenceError
  var bar = 1;
  let foo = 2; // End of TDZ (for foo)
}
</pre>

<p>The term "temporal" is used because the zone depends on the order of execution (time) rather than the order in which the code is written (position). For example, the code below works because, even though the function that uses the <code>let</code> variable appears before the variable is declared, the function is <em>called</em> outside the TDZ.</p>

<pre class="brush: js notranslate">{
    // TDZ starts at beginning of scope
    const func = () =&gt; console.log(letVar); // OK

    // Within the TDZ letVar access throws `ReferenceError`

    let letVar = 3; // End of TDZ (for letVar)
    func(); // Called outside TDZ!
}
</pre>

<h4 id="The_TDZ_and_typeof">The TDZ and <code>typeof</code></h4>

<p>Using the <code>typeof</code> operator for a <code>let</code> variable in its TDZ will throw a {{jsxref("ReferenceError")}}:</p>

<pre class="brush: js example-bad notranslate">// results in a 'ReferenceError'
console.log(typeof i);
let i = 10;</pre>

<p>This differs from using <code>typeof</code> for undeclared variables, and variables that hold a value of <code>undefined</code>:</p>

<pre class="brush: js notranslate">// prints out 'undefined'
console.log(typeof undeclaredVariable);
</pre>

<h4 id="TDZ_combined_with_lexical_scoping">TDZ combined with lexical scoping</h4>

<p>The following code results in a <code>ReferenceError</code> at the line shown:</p>

<pre class="brush: js example-bad notranslate">function test(){
   var foo = 33;
   if(foo) {
      let foo = (foo + 55); // ReferenceError
   }
}
test();</pre>

<p>The <code>if</code> block is evaluated because the outer <code>var foo</code> has a value. However due to lexical scoping this value is not available inside the block: the identifier <code>foo</code> <em>inside</em> the <code>if</code> block is the <code>let foo</code>. The expression <code>(foo + 55)</code> throws a <code>ReferenceError</code> because initialisation of <code>let foo</code> has not completed — it is still in the temporal dead zone.</p>

<p>This phenomenon can be confusing in a situation like the following. The instruction <code>let n of n.a</code> is already inside the private scope of the for loop's block. So, the identifier <code>n.a</code> is resolved to the property '<code>a</code>' of the '<code>n</code>' object located in the first part of the instruction itself (<code>let n</code>).</p>

<p>This is still in the temporal dead zone as its declaration statement has not been reached and terminated.</p>

<pre class="brush: js example-bad notranslate">function go(n) {
  // n here is defined!
  console.log(n); // Object {a: [1,2,3]}

  for (let n of n.a) { // ReferenceError
    console.log(n);
  }
}

go({a: [1, 2, 3]});
</pre>

<h3 id="Other_situations">Other situations</h3>

<p>When used inside a block, <strong><code>let</code></strong> limits the variable's scope to that block. Note the difference between <code><strong>var</strong></code>, whose scope is inside the function where it is declared.</p>

<pre class="brush: js notranslate">var a = 1;
var b = 2;

if (a === 1) {
  var a = 11; // the scope is global
  let b = 22; // the scope is inside the if-block

  console.log(a);  // 11
  console.log(b);  // 22
}

console.log(a); // 11
console.log(b); // 2
</pre>

<p>However, this combination of <code><strong>var</strong></code> and <strong><code>let</code></strong> declaration below is a {{jsxref("SyntaxError")}} due to <code><strong>var</strong></code> being hoisted to the top of the block. This results in an implicit re-declaration of the variable.</p>

<pre class="brush: js example-bad notranslate">let x = 1;

{
  var x = 2; // SyntaxError for re-declaration
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('ESDraft', '#sec-let-and-const-declarations', 'Let and Const Declarations')}}</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.let")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{jsxref("Statements/var", "var")}}</li>
	<li>{{jsxref("Statements/const", "const")}}</li>
	<li><a href="https://hacks.mozilla.org/2015/07/es6-in-depth-let-and-const/">ES6 In Depth: <code>let</code> and <code>const</code></a></li>
	<li><a href="https://blog.mozilla.org/addons/2015/10/14/breaking-changes-let-const-firefox-nightly-44/">Breaking changes in <code>let</code> and <code>const</code> in Firefox 44</a></li>
	<li><a href="https://github.com/getify/You-Dont-Know-JS/blob/1st-ed/scope%20%26%20closures/ch3.md">You Don't Know JS: Scope &amp; Closures: Chapter 3: Function vs. Block Scope</a></li>
	<li><a href="https://stackoverflow.com/a/33198850/1125029">StackOverflow: What is the Temporal Dead Zone</a>?</li>
	<li><a href="https://stackoverflow.com/questions/762011/whats-the-difference-between-using-let-and-var-to-declare-a-variable">StackOverflow: What is the difference between using <code>let</code> and <code>var</code>?</a></li>
</ul>
